﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Collections.ObjectModel;
using Telerik.Windows.Controls.DragDrop;
using System.Collections;
using Telerik.Windows;

namespace DragDrop2ListBoxes
{
	public partial class MainPage : UserControl
	{
		public MainPage()
		{
			InitializeComponent();

			listBox1.ItemsSource = new MyItemsSource();
			listBox2.ItemsSource = new ObservableCollection<string>();

			//Wire the events:
			listBox1.AddHandler(RadDragAndDropManager.DropQueryEvent, new EventHandler<DragDropQueryEventArgs>(OnDropQuery));
			listBox1.AddHandler(RadDragAndDropManager.DragQueryEvent, new EventHandler<DragDropQueryEventArgs>(OnDragQuery));
			listBox1.AddHandler(RadDragAndDropManager.DropInfoEvent, new EventHandler<DragDropEventArgs>(OnDropInfo));
			listBox1.AddHandler(RadDragAndDropManager.DragInfoEvent, new EventHandler<DragDropEventArgs>(OnDragInfo));
			listBox2.AddHandler(RadDragAndDropManager.DropQueryEvent, new EventHandler<DragDropQueryEventArgs>(OnDropQuery));
			listBox2.AddHandler(RadDragAndDropManager.DragQueryEvent, new EventHandler<DragDropQueryEventArgs>(OnDragQuery));
			listBox2.AddHandler(RadDragAndDropManager.DropInfoEvent, new EventHandler<DragDropEventArgs>(OnDropInfo));
			listBox2.AddHandler(RadDragAndDropManager.DragInfoEvent, new EventHandler<DragDropEventArgs>(OnDragInfo));
		}

		private void OnDragInfo(object sender, DragDropEventArgs e)
		{
			// if we are dropping on the appropriate listbox, then remove the item from the first listbox.
			if (e.Options.Status == DragStatus.DragComplete)
			{
				var listBox = e.Options.Source.FindItemsConrolParent() as ItemsControl;
				var itemsSource = listBox.ItemsSource as IList;
				itemsSource.Remove(e.Options.Payload);
			}
			// if we are dropping on the same listbox we started dragging from, just make the item visible.
			else if (e.Options.Status == DragStatus.DropCancel)
			{
				e.Options.Source.Visibility = Visibility.Visible;
			}
		}

		private void OnDropInfo(object sender, DragDropEventArgs e)
		{
			// if we are dropping on the appropriate listbox, then add the dragged item to it.
			var destination = e.Options.Destination;
			if (e.Options.Status == DragStatus.DropComplete && destination is ListBox)
			{
				var listBox = e.Options.Destination as ListBox;
				var itemsSource = listBox.ItemsSource as IList;
				itemsSource.Add(e.Options.Payload);
			}
		}

		private void OnDropQuery(object sender, DragDropQueryEventArgs e)
		{
			var destination = e.Options.Destination;

			if (e.Options.Status == DragStatus.DropDestinationQuery && destination is ListBox)
			{
				e.QueryResult = true;
				e.Handled = true;
			}
		}

		private void OnDragQuery(object sender, DragDropQueryEventArgs e)
		{
			if (e.Options.Status == DragStatus.DragQuery)
			{
				var listBoxItem = e.Options.Source;
				// Make the dragged item collapsed so it is not seen in the listbox
				listBoxItem.Visibility = Visibility.Collapsed;
				e.QueryResult = true;
				e.Handled = true;
				e.Options.DragCue = listBoxItem.DataContext;
				e.Options.Payload = listBoxItem.DataContext;
			}

			if (e.Options.Status == DragStatus.DropSourceQuery)
			{
				e.QueryResult = true;
				e.Handled = true;
			}
		}
	}
}
